Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 2371)
@@ -422,5 +422,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  1000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2371)
@@ -422,5 +422,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  1000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 2371)
@@ -430,4 +430,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  1000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2371)
@@ -467,5 +467,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  2000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2371)
@@ -467,5 +467,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  2000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 2371)
@@ -467,5 +467,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =  2000.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/CONFIG/POMME/EXP00/namelist	(revision 2371)
@@ -467,5 +467,6 @@
    ln_traldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
    ln_traldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
-   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")
+   ln_traldf_grif   =  .false.  !     griffies skew flux formulation    (require "key_ldfslp")   ! UNDER TEST, DO NOT USE
+   ln_traldf_gdia   =  .false.  !     griffies operator strfn diagnostics (require "key_ldfslp") ! UNDER TEST, DO NOT USE
                            !  Coefficient
    rn_aht_0         =   300.    !     horizontal eddy diffusivity for tracers [m2/s]
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 2371)
@@ -87,46 +87,83 @@
       ! 1. Compute lateral diffusive coefficient 
       ! ----------------------------------------
-
-      DO jk = 1, jpk
+      IF (ln_traldf_grif) THEN
+         DO jk = 1, jpk
 #  if defined key_vectopt_loop  
-!CDIR NOVERRCHK 
-         DO ji = 1, jpij   ! vector opt.
-            ! Take the max of N^2 and zero then take the vertical sum
-            ! of the square root of the resulting N^2 ( required to compute
-            ! internal Rossby radius Ro = .5 * sum_jpk(N) / f
-            zn2 = MAX( rn2b(ji,1,jk), 0.e0 )
-            zn(ji,1) = zn(ji,1) + SQRT( zn2 ) * fse3w(ji,1,jk)
-            ! Compute elements required for the inverse time scale of baroclinic
-            ! eddies using the isopycnal slopes calculated in ldfslp.F :
-            ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
-            ze3w = fse3w(ji,1,jk) * tmask(ji,1,jk)
+            !CDIR NOVERRCHK 
+            DO ji = 1, jpij   ! vector opt.
+               ! Take the max of N^2 and zero then take the vertical sum
+               ! of the square root of the resulting N^2 ( required to compute
+               ! internal Rossby radius Ro = .5 * sum_jpk(N) / f
+               zn2 = MAX( rn2b(ji,1,jk), 0.e0 )
+               zn(ji,1) = zn(ji,1) + SQRT( zn2 ) * fse3w(ji,1,jk)
+               ! Compute elements required for the inverse time scale of baroclinic
+               ! eddies using the isopycnal slopes calculated in ldfslp.F :
+               ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
+               ze3w = fse3w(ji,1,jk) * tmask(ji,1,jk)
+               zah(ji,1) = zah(ji,1) + zn2 * wslp2(ji,1,jk) * ze3w
+               zhw(ji,1) = zhw(ji,1) + ze3w
+            END DO
+#  else
+            DO jj = 2, jpjm1
+               !CDIR NOVERRCHK 
+               DO ji = 2, jpim1
+                  ! Take the max of N^2 and zero then take the vertical sum 
+                  ! of the square root of the resulting N^2 ( required to compute 
+                  ! internal Rossby radius Ro = .5 * sum_jpk(N) / f 
+                  zn2 = MAX( rn2b(ji,jj,jk), 0.e0 )
+                  zn(ji,jj) = zn(ji,jj) + SQRT( zn2 ) * fse3w(ji,jj,jk)
+                  ! Compute elements required for the inverse time scale of baroclinic
+                  ! eddies using the isopycnal slopes calculated in ldfslp.F : 
+                  ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
+                  ze3w = fse3w(ji,jj,jk) * tmask(ji,jj,jk)
+                  zah(ji,jj) = zah(ji,jj) + zn2 * wslp2(ji,jj,jk) * ze3w
+                  zhw(ji,jj) = zhw(ji,jj) + ze3w
+               END DO
+            END DO
+#  endif
+         END DO
+      ELSE
+         DO jk = 1, jpk
+#  if defined key_vectopt_loop  
+            !CDIR NOVERRCHK 
+            DO ji = 1, jpij   ! vector opt.
+               ! Take the max of N^2 and zero then take the vertical sum
+               ! of the square root of the resulting N^2 ( required to compute
+               ! internal Rossby radius Ro = .5 * sum_jpk(N) / f
+               zn2 = MAX( rn2b(ji,1,jk), 0.e0 )
+               zn(ji,1) = zn(ji,1) + SQRT( zn2 ) * fse3w(ji,1,jk)
+               ! Compute elements required for the inverse time scale of baroclinic
+               ! eddies using the isopycnal slopes calculated in ldfslp.F :
+               ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
+               ze3w = fse3w(ji,1,jk) * tmask(ji,1,jk)
                zah(ji,1) = zah(ji,1) + zn2   &
-                              * ( wslpi(ji,1,jk) * wslpi(ji,1,jk)    &
-                                + wslpj(ji,1,jk) * wslpj(ji,1,jk) )   &
-                              * ze3w
-            zhw(ji,1) = zhw(ji,1) + ze3w
-         END DO
+                    * ( wslpi(ji,1,jk) * wslpi(ji,1,jk)    &
+                    + wslpj(ji,1,jk) * wslpj(ji,1,jk) )   &
+                    * ze3w
+               zhw(ji,1) = zhw(ji,1) + ze3w
+            END DO
 #  else
-         DO jj = 2, jpjm1
-!CDIR NOVERRCHK 
-            DO ji = 2, jpim1
-               ! Take the max of N^2 and zero then take the vertical sum 
-               ! of the square root of the resulting N^2 ( required to compute 
-               ! internal Rossby radius Ro = .5 * sum_jpk(N) / f 
-               zn2 = MAX( rn2b(ji,jj,jk), 0.e0 )
-               zn(ji,jj) = zn(ji,jj) + SQRT( zn2 ) * fse3w(ji,jj,jk)
-               ! Compute elements required for the inverse time scale of baroclinic
-               ! eddies using the isopycnal slopes calculated in ldfslp.F : 
-               ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
-               ze3w = fse3w(ji,jj,jk) * tmask(ji,jj,jk)
-               zah(ji,jj) = zah(ji,jj) + zn2   &
-                              * ( wslpi(ji,jj,jk) * wslpi(ji,jj,jk)    &
-                                + wslpj(ji,jj,jk) * wslpj(ji,jj,jk) )  &
-                              * ze3w
-               zhw(ji,jj) = zhw(ji,jj) + ze3w
-            END DO 
-         END DO 
+            DO jj = 2, jpjm1
+               !CDIR NOVERRCHK 
+               DO ji = 2, jpim1
+                  ! Take the max of N^2 and zero then take the vertical sum 
+                  ! of the square root of the resulting N^2 ( required to compute 
+                  ! internal Rossby radius Ro = .5 * sum_jpk(N) / f 
+                  zn2 = MAX( rn2b(ji,jj,jk), 0.e0 )
+                  zn(ji,jj) = zn(ji,jj) + SQRT( zn2 ) * fse3w(ji,jj,jk)
+                  ! Compute elements required for the inverse time scale of baroclinic
+                  ! eddies using the isopycnal slopes calculated in ldfslp.F : 
+                  ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
+                  ze3w = fse3w(ji,jj,jk) * tmask(ji,jj,jk)
+                  zah(ji,jj) = zah(ji,jj) + zn2   &
+                       * ( wslpi(ji,jj,jk) * wslpi(ji,jj,jk)    &
+                       + wslpj(ji,jj,jk) * wslpj(ji,jj,jk) )  &
+                       * ze3w
+                  zhw(ji,jj) = zhw(ji,jj) + ze3w
+               END DO
+            END DO
 #  endif
-      END DO 
+         END DO
+      END IF
 
       DO jj = 2, jpjm1
Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2371)
@@ -9,5 +9,5 @@
    !!   NEMO     0.5  ! 2002-10  (G. Madec)  Free form, F90
    !!            1.0  ! 2005-10  (A. Beckmann)  correction for s-coordinates
-   !!            3.3  ! 2006-10  (C. Harris, G. Nurser)  add ldf_slp_grif (Griffies operator)
+   !!            3.3  ! 2010-10  (G. Nurser, C. Harris, G. Madec)  add Griffies operator
    !!----------------------------------------------------------------------
 #if   defined key_ldfslp   ||   defined key_esopa
@@ -15,15 +15,16 @@
    !!   'key_ldfslp'                      Rotation of lateral mixing tensor
    !!----------------------------------------------------------------------
-   !!   ldf_slp      : compute the slopes of neutral surface
-   !!   ldf_slp_mxl  : compute the slopes of iso-neutral surface
+   !!   ldf_slp_grif : calculates the triads of isoneutral slopes (Griffies operator)
+   !!   ldf_slp      : calculates the slopes of neutral surface   (Madec operator)
+   !!   ldf_slp_mxl  : calculates the slopes at the base of the mixed layer (Madec operator)
    !!   ldf_slp_init : initialization of the slopes computation
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
-   USE ldftra_oce
-   USE ldfdyn_oce
+   USE ldftra_oce      ! lateral diffusion: traceur
+   USE ldfdyn_oce      ! lateral diffusion: dynamics
    USE phycst          ! physical constants
    USE zdfmxl          ! mixed layer depth
-   USE eosbn2
+   USE eosbn2          ! equation of states
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
@@ -33,20 +34,23 @@
    PRIVATE
 
-   PUBLIC   ldf_slp         ! routine called by step.F90
-   PUBLIC   ldf_slp_init    ! routine called by opa.F90
-   PUBLIC   ldf_slp_grif    ! routine called by step.F90
-
-   LOGICAL , PUBLIC, PARAMETER              ::   lk_ldfslp = .TRUE.   !: slopes flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   uslp, wslpi          !: i_slope at U- and W-points
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   vslp, wslpj          !: j-slope at V- and W-points
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   wslp2                !: wslp**2 from Griffies quarter cells
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   alpha, beta          !: alpha,beta at T points
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   tfw,sfw,ftu,fsu,ftv,fsv,ftud,fsud,ftvd,fsvd
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   psix_eiv
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   psiy_eiv
-   
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   omlmask           ! mask of the surface mixed layer at T-pt
-   REAL(wp), DIMENSION(jpi,jpj)     ::   uslpml, wslpiml   ! i_slope at U- and W-points just below the mixed layer
-   REAL(wp), DIMENSION(jpi,jpj)     ::   vslpml, wslpjml   ! j_slope at V- and W-points just below the mixed layer
+   PUBLIC   ldf_slp        ! routine called by step.F90
+   PUBLIC   ldf_slp_grif   ! routine called by step.F90
+   PUBLIC   ldf_slp_init   ! routine called by opa.F90
+
+   LOGICAL , PUBLIC, PARAMETER ::   lk_ldfslp = .TRUE.     !: slopes flag
+   !                                                                             !! Madec operator
+   REAL(wp), PUBLIC, DIMENSION(:,:,:)    , ALLOCATABLE ::   uslp, wslpi          !: i_slope at U- and W-points
+   REAL(wp), PUBLIC, DIMENSION(:,:,:)    , ALLOCATABLE ::   vslp, wslpj          !: j-slope at V- and W-points
+   !                                                                             !! Griffies operator
+   REAL(wp), PUBLIC, DIMENSION(:,:,:)    , ALLOCATABLE ::   wslp2                !: wslp**2 from Griffies quarter cells
+   REAL(wp), PUBLIC, DIMENSION(:,:,:,:,:), ALLOCATABLE ::   triadi_g, triadj_g   !: skew flux  slopes relative to geopotentials 
+   REAL(wp), PUBLIC, DIMENSION(:,:,:,:,:), ALLOCATABLE ::   triadi  , triadj     !: isoneutral slopes relative to model-coordinate
+
+   !                                                              !! Madec operator
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   omlmask           ! mask of the surface mixed layer at T-pt
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE ::   uslpml, wslpiml   ! i_slope at U- and W-points just below the mixed layer
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE ::   vslpml, wslpjml   ! j_slope at V- and W-points just below the mixed layer
+
+   REAL(wp) ::   repsln = 1.e-25_wp       ! tiny value used as minium of di(rho), dj(rho) and dk(rho)
 
    !! * Substitutions
@@ -67,5 +71,5 @@
       !! 
       !! ** Purpose :   Compute the slopes of neutral surface (slope of isopycnal
-      !!              surfaces referenced locally) ('key_traldfiso').
+      !!              surfaces referenced locally) (ln_traldf_iso=T).
       !! 
       !! ** Method  :   The slope in the i-direction is computed at U- and 
